
#ifndef _H_SEQUENCE

#include <stdbool.h>

typedef struct list_struct * list;
typedef struct entry_struct * entry;

void lst_init(list *);
void lst_free(list *);
void lst_free_data(list *, void (*)(void *));
const entry lst_push(list, void *);
const entry lst_insert_after(const list, const entry, void *);
void * lst_pop(list);
bool lst_empty(list);
void lst_clear(list);
void lst_clear_data(list, void (*)(void *));
const entry lst_first(const list);
const entry lst_next(const entry);
void * lst_data(const entry);

#define lst_forall(a,l) for (a = lst_first(l); a != NULL; a = lst_next(a))

#endif
